Require Import connectives.
Require Import leibniz.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Definition le_S_S : forall (n:nat), forall (m:nat), (le n m) -> le (S n) (S m) := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (S n) (S x_417))) ((le_n) (S n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (S n) (S m0)) => ((((le_S) (S n)) (S m0)) (_x_421))))) (m)) (lenm)).
Definition monotonic_le_plus_r : forall (n:nat), relations.monotonic (nat) le (fun (m:nat) => plus n m) := fun (n:nat) => fun (a:nat) => fun (b:nat) => ((((nat_ind) (fun (_x_365:nat) => (le a b) -> le (plus _x_365 a) (plus _x_365 b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (plus O a) (y b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (y a) b)) (fun (auto:le a b) => (auto))))))))) (fun (m:nat) => fun (H:(le a b) -> le (plus m a) (plus m b)) => (fun (leab:le a b) => ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (plus (S m) a) (y b))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (y a) (S (plus m b)))) ((((le_S_S) (plus m a)) (plus m b)) ((H) (leab)))))))))))) (n).
